
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Document_template_variablesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const document_template_variables = await db.document_template_variables.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        key: data.key
        ||
        null
            ,
            
        data_type: data.data_type
        ||
        null
            ,
            
        is_required_minimum: data.is_required_minimum
        ||
        false
        
            ,
            
        is_desired: data.is_desired
        ||
        false
        
            ,
            
        help_text: data.help_text
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await document_template_variables.setDocument_type( data.document_type || null, {
            transaction,
        });
        
        await document_template_variables.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return document_template_variables;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const document_template_variablesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                key: item.key
            ||
            null
            ,
            
                data_type: item.data_type
            ||
            null
            ,
            
                is_required_minimum: item.is_required_minimum
            ||
            false
        
            ,
            
                is_desired: item.is_desired
            ||
            false
        
            ,
            
                help_text: item.help_text
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const document_template_variables = await db.document_template_variables.bulkCreate(document_template_variablesData, { transaction });

        // For each item created, replace relation files
        

        return document_template_variables;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const document_template_variables = await db.document_template_variables.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.key !== undefined) updatePayload.key = data.key;
        
        
        if (data.data_type !== undefined) updatePayload.data_type = data.data_type;
        
        
        if (data.is_required_minimum !== undefined) updatePayload.is_required_minimum = data.is_required_minimum;
        
        
        if (data.is_desired !== undefined) updatePayload.is_desired = data.is_desired;
        
        
        if (data.help_text !== undefined) updatePayload.help_text = data.help_text;
        
        
        updatePayload.updatedById = currentUser.id;

        await document_template_variables.update(updatePayload, {transaction});

        
        
        if (data.document_type !== undefined) {
            await document_template_variables.setDocument_type(
              
              data.document_type,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await document_template_variables.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return document_template_variables;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const document_template_variables = await db.document_template_variables.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of document_template_variables) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of document_template_variables) {
                await record.destroy({transaction});
            }
        });


        return document_template_variables;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const document_template_variables = await db.document_template_variables.findByPk(id, options);

        await document_template_variables.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await document_template_variables.destroy({
            transaction
        });

        return document_template_variables;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const document_template_variables = await db.document_template_variables.findOne(
            { where },
            { transaction },
        );

        if (!document_template_variables) {
            return document_template_variables;
        }

        const output = document_template_variables.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.document_type = await document_template_variables.getDocument_type({
            transaction
        });
        
        
        output.organizations = await document_template_variables.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.document_types,
        as: 'document_type',
        
        where: filter.document_type ? {
          [Op.or]: [
            { id: { [Op.in]: filter.document_type.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.document_type.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'document_template_variables',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'document_template_variables',
                        'key',
                        filter.key,
                    ),
                };
            }
            
            if (filter.help_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'document_template_variables',
                        'help_text',
                        filter.help_text,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.data_type) {
                where = {
                    ...where,
                data_type: filter.data_type,
            };
            }
            
            if (filter.is_required_minimum) {
                where = {
                    ...where,
                is_required_minimum: filter.is_required_minimum,
            };
            }
            
            if (filter.is_desired) {
                where = {
                    ...where,
                is_desired: filter.is_desired,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.document_template_variables.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'document_template_variables',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.document_template_variables.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

